using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Stimulsoft.Report;
using Stimulsoft.Report.Components;
using Stimulsoft.Base.Drawing;
using Stimulsoft.Base;

namespace SampleProject
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void bShow_Click(object sender, EventArgs e)
        {
            StiReport report = new StiReport();
            StiPage page = report.Pages[0];

            DataSet ds = new DataSet("Demo");
            ds.ReadXmlSchema("d:\\Demo.xsd");
            ds.ReadXml("d:\\Demo.xml");

            DataTable dt = new DataTable("Categories");
            dt = ds.Tables["Categories"];

            report.RegData(ds);
            report.Dictionary.Synchronize();

            //Create TitleBand
            StiHeaderBand TitleBand = new StiHeaderBand();
            TitleBand.Height = 0.85;
            TitleBand.Name = "TitleBand";
            page.Components.Add(TitleBand);

            //Create Title text on header
            StiText headerText = new StiText(new RectangleD(0, 0, page.Width, 0.85));
            headerText.Text = "Tacticdescription";
            headerText.HorAlignment = StiTextHorAlignment.Left;
            headerText.Name = "TitleHeader";
            headerText.Font = new System.Drawing.Font("Arial", 12F, System.Drawing.FontStyle.Bold);
            TitleBand.Components.Add(headerText);

            //Create HeaderBand
            StiHeaderBand headerBand = new StiHeaderBand();
            headerBand.Height = 0.5;
            headerBand.Name = "HeaderBand";
            page.Components.Add(headerBand);

            //Create Databand
            StiDataBand dataBand = new StiDataBand();
            dataBand.DataSourceName = "Categories";
            dataBand.Height = 0.5;
            dataBand.Name = "DataBand";
            page.Components.Add(dataBand);


            double pos = 0;
            double columnWidth = page.Width/dt.Columns.Count;
            int nameIndex = 1;
            foreach (DataColumn dataColumn in dt.Columns)
            {
                    //Create text on header
                    StiText hText = new StiText(new RectangleD(pos, 0, columnWidth, 0.5));
                    hText = new StiText(new RectangleD(pos, 0, columnWidth, 0.5));

                    hText.Text.Value = dataColumn.Caption;
                    hText.HorAlignment = StiTextHorAlignment.Center;
                    hText.Name = "HeaderText" + nameIndex.ToString();
                    hText.Brush = new StiSolidBrush(Color.Orange);
                    hText.Border.Side = StiBorderSides.All;
                    headerBand.Components.Add(hText);

                    StiText dataText = new StiText(new RectangleD(pos, 0, columnWidth, 0.5));

                    dataText.Text = "{Categories." + Stimulsoft.Report.CodeDom.StiCodeDomSerializator.ReplaceSymbols(dataColumn.ColumnName) + "}";
                    dataText.Name = "DataText" + nameIndex.ToString();
                    dataText.Border.Side = StiBorderSides.All;

                    dataBand.Components.Add(dataText);
                    pos = pos + columnWidth;
                    nameIndex++;
            }


            report.Compile();
            report.Show();
        }
    }
}